import "antd/es/tooltip/style";
import _Tooltip from "antd/es/tooltip";

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import './ThemeColor.less';
import { CheckOutlined } from '@ant-design/icons';
import React from 'react';
import { genThemeToString } from '../utils/utils';
var Tag = /*#__PURE__*/React.forwardRef(function (_a, ref) {
  var color = _a.color,
      check = _a.check,
      rest = __rest(_a, ["color", "check"]);

  return /*#__PURE__*/React.createElement("div", Object.assign({}, rest, {
    style: {
      backgroundColor: color
    },
    ref: ref
  }), check ? /*#__PURE__*/React.createElement(CheckOutlined, null) : '');
});

var ThemeColor = function ThemeColor(_ref, ref) {
  var colors = _ref.colors,
      value = _ref.value,
      onChange = _ref.onChange,
      formatMessage = _ref.formatMessage;
  var colorList = colors || [];

  if (colorList.length < 1) {
    return null;
  }

  return /*#__PURE__*/React.createElement("div", {
    className: "theme-color",
    ref: ref
  }, /*#__PURE__*/React.createElement("div", {
    className: "theme-color-content"
  }, colorList.map(function (_ref2) {
    var key = _ref2.key,
        color = _ref2.color;
    var themeKey = genThemeToString(key);
    return /*#__PURE__*/React.createElement(_Tooltip, {
      key: color,
      title: themeKey ? formatMessage({
        id: "app.setting.themecolor.".concat(themeKey)
      }) : key
    }, /*#__PURE__*/React.createElement(Tag, {
      className: "theme-color-block",
      color: color,
      check: value === key || genThemeToString(value) === key,
      onClick: function onClick() {
        return onChange && onChange(key);
      }
    }));
  })));
};

export default /*#__PURE__*/React.forwardRef(ThemeColor);