"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/lib/tooltip/style");

var _tooltip = _interopRequireDefault(require("antd/lib/tooltip"));

require("./ThemeColor.less");

var _icons = require("@ant-design/icons");

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var Tag = /*#__PURE__*/_react.default.forwardRef(function (_a, ref) {
  var color = _a.color,
      check = _a.check,
      rest = __rest(_a, ["color", "check"]);

  return /*#__PURE__*/_react.default.createElement("div", Object.assign({}, rest, {
    style: {
      backgroundColor: color
    },
    ref: ref
  }), check ? /*#__PURE__*/_react.default.createElement(_icons.CheckOutlined, null) : '');
});

var ThemeColor = function ThemeColor(_ref, ref) {
  var colors = _ref.colors,
      value = _ref.value,
      onChange = _ref.onChange,
      formatMessage = _ref.formatMessage;
  var colorList = colors || [];

  if (colorList.length < 1) {
    return null;
  }

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "theme-color",
    ref: ref
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "theme-color-content"
  }, colorList.map(function (_ref2) {
    var key = _ref2.key,
        color = _ref2.color;
    var themeKey = (0, _utils.genThemeToString)(key);
    return /*#__PURE__*/_react.default.createElement(_tooltip.default, {
      key: color,
      title: themeKey ? formatMessage({
        id: "app.setting.themecolor.".concat(themeKey)
      }) : key
    }, /*#__PURE__*/_react.default.createElement(Tag, {
      className: "theme-color-block",
      color: color,
      check: value === key || (0, _utils.genThemeToString)(value) === key,
      onClick: function onClick() {
        return onChange && onChange(key);
      }
    }));
  })));
};

var _default = /*#__PURE__*/_react.default.forwardRef(ThemeColor);

exports.default = _default;